package eu.univento.lobby.listeners;

import java.sql.SQLException;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import eu.univento.core.api.CustomPlayer;
import eu.univento.core.api.Title;
import eu.univento.lobby.utils.Inventorys;

/**
 * some join / quit events
 * @author joethei
 * @version 1.0
 */
public class JoinQuit implements Listener{
	
	/**
	 * handles player joining
	 * @param e PlayerJoinEvent
	 * @throws ClassNotFoundException Class could not be found
	 * @throws SQLException SQL server is not available or throws error
	 */
	@EventHandler
	public void onJoin(PlayerJoinEvent e) throws ClassNotFoundException, SQLException {
		CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer().getName());
		//NPC.injectNetty(p.getPLAYER());
		
		p.setGameMode(GameMode.ADVENTURE);
		p.setFoodLevel(10);
		p.setMaxHealth(10.0D);
		p.setHealth(1.0D);
		p.addPotionEffect(new PotionEffect(PotionEffectType.REGENERATION, 100, 2));
		p.teleport(Bukkit.getWorld("world").getSpawnLocation());
		for(int i = 0; i <= 100; i++) {
		    p.sendMessage(" ");
		}
		p.sendMessage("6Willkommen auf 3univento.eu");
		Title.sendTitle(p, 10, 50, 10, "3univento.eu", "6Das Netzwerk mit Style");
		Title.sendTabTitle(p, "6" + Bukkit.getServerName(), "3univento.eu");
		
		Inventorys.openMainInventory(p);
				
	}
	
	 /**
	  * removes player from lists
	 * @param e PlayerQuitEvent
	 */
	@EventHandler
	 public void onQuit(PlayerQuitEvent e) {
		 CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer().getName());
		 p.getInventory().clear();
		 //NPC.ejectNetty(p.getPLAYER());
	 }
	
}